(** @author: Benoît Montagu <benoit.montagu@inria.fr>
    Copyright © Inria 2021 *)

type t = Lexing.position * Lexing.position

let get lexbuf = (Lexing.lexeme_start_p lexbuf, Lexing.lexeme_end_p lexbuf)

let pp fmt (start_p, end_p) =
  let open Lexing in
  if String.equal "" start_p.pos_fname then
    Format.fprintf fmt "Line %i, characters %i-%i:" start_p.pos_lnum
      (start_p.pos_cnum - start_p.pos_bol)
      (end_p.pos_cnum - start_p.pos_bol)
  else
    Format.fprintf fmt "File \"%s\", line %i, characters %i-%i:"
      start_p.pos_fname start_p.pos_lnum
      (start_p.pos_cnum - start_p.pos_bol)
      (end_p.pos_cnum - start_p.pos_bol)
